import axios from "@/plugins/axios-console.js";

export default {
    async _req(url, data, func) {
        if (!func) func = () => {};
        try {
            return await axios.post(url, data);
        } catch (error) {
            func(error);
            throw error;
        }
    },
    async tempPage(data, func) {
        return await this._req("/temp/page", data, func);
    },
    async tempCreate(data, func) {
        return await this._req("/temp/create", data, func);
    },
    async tempUpdate(data, func) {
        return await this._req("/temp/update", data, func);
    },
    async tempRemove(data, func) {
        return await this._req("/temp/remove", data, func);
    },
    async tempAvailables(func) {
        return await this._req("/temp/availables", {}, func);
    },
    
    async orderPage(data, func) {
        return await this._req("/order/page", data, func);
    },
    async orderCreate(data, func) {
        return await this._req("/order/create", data, func);
    },
    async orderUpdate(data, func) {
        return await this._req("/order/update", data, func);
    },
    async orderRemove(data, func) {
        return await this._req("/order/remove", data, func);
    },
    async orderStatistics(data, func) {
        return await this._req("/order/statistics", data, func);
    },
    async orderRecords(data, func) {
        return await this._req("/order/records", data, func);
    },
    async login(data, func) {
        return await this._req("/user/login", data, func);
    },
    async sessionInfo(func) {
        return await this._req("/user/session_info", {}, func);
    },
    async userCreate(data, func) {
        return await this._req("/user/create", data, func);
    },
    async userUpdate(data, func) {
        return await this._req("/user/update", data, func);
    },
    async userUpdatePwd(data, func) {
        return await this._req("/user/updatePwd", data, func);
    },
    async userPage(data, func) {
        return await this._req("/user/page", data, func);
    },
    async userRemove(data, func) {
        return await this._req("/user/remove", data, func);
    }
};