import qs from 'qs';
import axios from 'axios';

var instance = axios.create({
    method: 'post',
    baseURL: process.env.VUE_APP_URL,
    headers: {
        'Content-Type': 'application/x-www-form-urlencoded'
    },
    transformRequest: [function (data) {
      
        data = Object.assign({}, data);
        
        data.session_token = localStorage.getItem("session_token");
        
        
        for (var key in data) {
            var obj = data[key];
            if (Object.prototype.toString.call(obj) == '[object Array]') {
                data[key] = obj.join(',');
            }
        }
        var r = qs.stringify(Object.assign({},data))
        //console.log(r)
        return r;
    }]
});


// 添加响应拦截器
instance.interceptors.response.use(function (response) {
    // 对响应数据做点什么
    var data = response.data;
    if(data.result_code=='SUCCESS'){
        return data;
    }
    if(data.result_code=='FAIL'&&data.err_code=='LOGIN_TIMEOUT'){
        location.replace('/login');
        return;
    }
    throw data
}, function (error) {
    throw {
        result_code: 'FAIL',
        err_code: "-10000",
        err_des: "网络异常[-10000][" + error + "]"
    };
});

export default instance