import Vue from 'vue'
import qs from 'qs';
Vue.mixin({
  data () {
    return {
      page: {
        number: 1,
        size: 20,
        totalPages: 0,
        content: [],
        ext:{}
      }
    }
  },
  mounted () {
    this._params = Object.assign({}, this.params)
  },
  methods: {
    openLink(abspath){
      var ps= this.serializable()
      var url = process.env.VUE_APP_URL+abspath;
      if(url.indexOf('?')>=0){
        url +='&'+ps;
      }else{
        url +='?'+ps;
      }
      window.open(url);
    },
    serializable(){
      var data = Object.assign({},{
        session_token:localStorage.getItem('session_token')
      }, this.params);
      for (var key in data) {
        var obj = data[key];
        if (Object.prototype.toString.call(obj) == '[object Array]') {
            data[key] = obj.join(',');
        }
    }
    return qs.stringify(Object.assign({},data))
      
    },
    reset () {
      this.$refs.form.resetFields()
    },
    dl (name, row) {
      var dl = this.$refs[name]
      dl.open(row)
    },
    beforeDelete (row) {
      this.$confirm('此操作不可恢复, 是否继续?', '提示', {
        confirmButtonText: '确定',
        cancelButtonText: '取消',
        type: 'warning'
      }).then(() => {
        this.ajaxDelete(row)
      })
    },
    submitForm () {
      this.$refs.form.validate(valid => {
        if (!valid) return
        this.ajaxSubmit()
      })
    },
    reload (a) {
      if(parseInt(a)){
        this.page.size =a;
      }
        this.loadPage(0, this.page.size)
      
    },
    initPage (page) {
      this.page.totalElements = page.totalElements
      this.page.content = page.content
      this.page.size = page.size
      this.page.number = page.number + 1
      this.page.totalPages = page.totalPages
      this.page.ext = page.ext
    },
    refresh () {
      this.loadPage(this.page.number - 1, this.page.size)
    },
    handleCurrentChange (a, b) {
      console.log('handleCurrentChange',a,b);
      this.loadPage(a - 1, this.page.size)
    },
    resetParams () {
      this.params = Object.assign({}, this._params)
    }
  }
})
